//+------------------------------------------------------------------+
//|                                                     Momentum.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red

#property indicator_level1 100
#property indicator_levelcolor SlateGray

//---- input parameters
extern int MomPeriod=14;
//---- buffers
double MomBuffer[];
double ColorBuffer[];
double ColorBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexBuffer(0,MomBuffer);
   SetIndexBuffer(1,ColorBuffer); 
   SetIndexBuffer(2,ColorBuffer1); 
   

//---- name for DataWindow and indicator subwindow label
   short_name="Momentum Color ("+MomPeriod+") ";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=MomPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=MomPeriod;i++) MomBuffer[Bars-i]=0.0;
//----
   i=Bars-MomPeriod-1;
   if(counted_bars>=MomPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {

      MomBuffer[i]=Close[i]*100/Close[i+MomPeriod];

     ColorBuffer [i]=EMPTY_VALUE;     ColorBuffer1[i]=EMPTY_VALUE;


       //Print (ma[shift]);
        if (MomBuffer[i] < MomBuffer[i+1])
        {
        
         if (ColorBuffer[i+2] !=EMPTY_VALUE) 
            {
            ColorBuffer1[i+1]=MomBuffer[i+1];   ColorBuffer1[i]=MomBuffer[i];
               }
            else 
            {
            ColorBuffer[i]=MomBuffer[i];        ColorBuffer[i+1]=MomBuffer[i+1];
               }

         }

      
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+